MRuby::Build.new do |conf|
  # load specific toolchain settings

  # Gets set by the VS command prompts.
  if ENV['VisualStudioVersion'] || ENV['VSINSTALLDIR']
    toolchain :visualcpp
  else
    toolchain :gcc
  end

  # Turn on `enable_debug` for better debugging
  # enable_debug

  # Use mrbgems
  # conf.gem 'examples/mrbgems/ruby_extension_example'
  # conf.gem 'examples/mrbgems/c_extension_example' do |g|
  #   g.cc.flags << '-g' # append cflags in this gem
  # end
  # conf.gem 'examples/mrbgems/c_and_ruby_extension_example'
  # conf.gem :core => 'mruby-eval'
  # conf.gem :mgem => 'mruby-onig-regexp'
  # conf.gem :github => 'mattn/mruby-onig-regexp'
  # conf.gem :git => 'git@github.com:mattn/mruby-onig-regexp.git', :branch => 'master', :options => '-v'

  # include the default GEMs
  conf.gembox 'default'
  # C compiler settings
  # conf.cc do |cc|
  #   cc.command = ENV['CC'] || 'gcc'
  #   cc.flags = [ENV['CFLAGS'] || %w()]
  #   cc.include_paths = ["#{root}/include"]
  #   cc.defines = %w()
  #   cc.option_include_path = %q[-I"%s"]
  #   cc.option_define = '-D%s'
  #   cc.compile_options = %Q[%{flags} -MMD -o "%{outfile}" -c "%{infile}"]
  # end

  # mrbc settings
  # conf.mrbc do |mrbc|
  #   mrbc.compile_options = "-g -B%{funcname} -o-" # The -g option is required for line numbers
  # end

  # Linker settings
  # conf.linker do |linker|
  #   linker.command = ENV['LD'] || 'gcc'
  #   linker.flags = [ENV['LDFLAGS'] || []]
  #   linker.flags_before_libraries = []
  #   linker.libraries = %w()
  #   linker.flags_after_libraries = []
  #   linker.library_paths = []
  #   linker.option_library = '-l%s'
  #   linker.option_library_path = '-L%s'
  #   linker.link_options = "%{flags} -o "%{outfile}" %{objs} %{libs}"
  # end

  # Archiver settings
  # conf.archiver do |archiver|
  #   archiver.command = ENV['AR'] || 'ar'
  #   archiver.archive_options = 'rs "%{outfile}" %{objs}'
  # end

  # Parser generator settings
  # conf.yacc do |yacc|
  #   yacc.command = ENV['YACC'] || 'bison'
  #   yacc.compile_options = %q[-o "%{outfile}" "%{infile}"]
  # end

  # gperf settings
  # conf.gperf do |gperf|
  #   gperf.command = 'gperf'
  #   gperf.compile_options = %q[-L ANSI-C -C -p -j1 -i 1 -g -o -t -N mrb_reserved_word -k"1,3,$" "%{infile}" > "%{outfile}"]
  # end

  # file extensions
  # conf.exts do |exts|
  #   exts.object = '.o'
  #   exts.executable = '' # '.exe' if Windows
  #   exts.library = '.a'
  # end

  # file separetor
  # conf.file_separator = '/'

  # bintest
  # conf.enable_bintest
end
=begin
MRuby::Build.new('host-debug') do |conf|
  # load specific toolchain settings

  # Gets set by the VS command prompts.
  if ENV['VisualStudioVersion'] || ENV['VSINSTALLDIR']
    toolchain :visualcpp
  else
    toolchain :gcc
  end

  enable_debug

  # include the default GEMs
  conf.gembox 'default'

  # C compiler settings
  conf.cc.defines = %w(MRB_ENABLE_DEBUG_HOOK)

  # Generate mruby debugger command (require mruby-eval)
  conf.gem :core => "mruby-bin-debugger"

  # bintest
  # conf.enable_bintest
end

MRuby::Build.new('test') do |conf|
  # Gets set by the VS command prompts.
  if ENV['VisualStudioVersion'] || ENV['VSINSTALLDIR']
    toolchain :visualcpp
  else
    toolchain :gcc
  end

  enable_debug
  conf.enable_bintest
  conf.enable_test

  conf.gembox 'default'
end
=end
#MRuby::Build.new('bench') do |conf|
#  # Gets set by the VS command prompts.
#  if ENV['VisualStudioVersion'] || ENV['VSINSTALLDIR']
#    toolchain :visualcpp
#  else
#    toolchain :gcc
#    conf.cc.flags << '-O3'
#  end
#
#  conf.gembox 'default'
#end

# Define cross build settings
# MRuby::CrossBuild.new('32bit') do |conf|
#   toolchain :gcc
#
#   conf.cc.flags << "-m32"
#   conf.linker.flags << "-m32"
#
#   conf.build_mrbtest_lib_only
#
#   conf.gem 'examples/mrbgems/c_and_ruby_extension_example'
#
#   conf.test_runner.command = 'env'
# end

# Cross build for arm-none-eabi
MRuby::CrossBuild.new('arm-none-eabi') do |conf|
  toolchain :gcc

  conf.cc.command = "arm-none-eabi-gcc"
  conf.cxx.command = "arm-none-eabi-g++"
  conf.linker.command = "arm-none-eabi-gcc"
  conf.archiver.command = "arm-none-eabi-ar"

  conf.cc.flags << %w(-MD -MP -mlittle-endian -mcpu=cortex-a9 -mthumb -mthumb-interwork -marm -march=armv7-a -mfpu=vfpv3 -mfloat-abi=hard -mno-unaligned-access -fno-strict-aliasing -nostdinc -Wstack-usage=256 -ffunction-sections -fdata-sections)
  conf.cc.include_paths  << "../musl-1.1.18/include"

  conf.cc.defines << %w(MRB_USE_CUSTOM_RO_DATA_P MRB_ENABLE_DEBUG_HOOK MRB_CONSTRAINED_BASELINE_PROFILE)

  #conf.build_mrbtest_lib_only

  conf.gem "#{root}/mrbgems/mruby-compiler"
  conf.gem "#{root}/mrbgems/mruby-eval"
  conf.gem "#{root}/mrbgems/mruby-io"
  conf.gem "#{root}/mrbgems/mruby-math"
  conf.gem "#{root}/mrbgems/mruby-pack"
  conf.gem "#{root}/mrbgems/mruby-print"
  conf.gem "#{root}/mrbgems/mruby-random"
  conf.gem "#{root}/mrbgems/mruby-socket"
  conf.gem "#{root}/mrbgems/mruby-sprintf"
  conf.gem "#{root}/mrbgems/mruby-struct"
  conf.gem "#{root}/mrbgems/mruby-time"
  conf.gem "#{root}/mrbgems/mruby-numeric-ext"
  conf.gem "#{root}/mrbgems/mruby-string-ext"
  conf.gem '../mrbgems/mruby-onig-regexp'  do |g|
    g.cc.flags << %w(-DHAVE_ONIGMO_H)
    g.cc.include_paths  << "../onigmo-6.1.3/src"
  end
  conf.gem "#{root}/../mrbgems/mruby-blockly"
  conf.gem "#{root}/../mrbgems/mruby-digest" do |g|
    g.cc.include_paths << "#{g.dir}/../../openssl-1.1.0e/include"
  end
  conf.gem "#{root}/../mrbgems/mruby-dir"
  conf.gem "#{root}/../mrbgems/mruby-env"
  conf.gem "#{root}/../mrbgems/mruby-errno"
  conf.gem "#{root}/../mrbgems/mruby-iijson"
  conf.gem "#{root}/../mrbgems/mruby-ipaddr"
  conf.gem "#{root}/../mrbgems/mruby-mock"
  #conf.gem "#{root}/../mrbgems/mruby-require"
  conf.gem "#{root}/../mrbgems/mruby-tls-openssl" do |g|
    g.cc.include_paths << "#{g.dir}/../../openssl-1.1.0e/include"
  end
  conf.gem "#{root}/../mrbgems/mruby-arduino" do |g|
    g.cc.include_paths << "#{g.dir}/../../prototool/src"
    g.cc.include_paths << "#{g.dir}/../../mbed_api/src"
  end
  conf.gem "#{root}/../mrbgems/mruby-ecnl"
  conf.gem "#{root}/../mrbgems/mruby-others"

  conf.bins = []

  # conf.test_runner.command = 'env'
end
=begin
MRuby::CrossBuild.new("emscripten") do |conf|
  toolchain :emscripten

  conf.archiver.command = "llvm-ar"
  conf.cc.flags << '-ffunction-sections -fdata-sections'
  conf.linker.flags << '-Wl,--gc-sections'
  conf.linker.flags << '--save-bc %{outfile}.bc --pre-js ../webapp/webmrbc/pre.js --post-js ../webapp/webmrbc/post.js --use-preload-plugins'
  #conf.linker.flags << '-s BINARYEN=1'
  #conf.exts.executable = '.html'

  # include the default GEMs
  #conf.gembox 'default'
  conf.gem :core => 'mruby-bin-mrbc'
end
=end
